VERSION 5.00
Begin VB.Form frmPluginMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Joystick"
   ClientHeight    =   270
   ClientLeft      =   1335
   ClientTop       =   1830
   ClientWidth     =   1560
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   270
   ScaleWidth      =   1560
   Begin VB.Timer timer 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   720
      Top             =   -240
   End
   Begin VB.CheckBox cb_active 
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   255
   End
   Begin VB.Label l_active 
      Caption         =   "Aktivieren"
      Height          =   255
      Left            =   360
      TabIndex        =   1
      Top             =   0
      Width           =   735
   End
End
Attribute VB_Name = "frmPluginMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Implements IDMXCTool
Implements IExternalWindow
Implements ICommandServer

Dim tolmin As Long, tolmax As Long
' c hat alle Kanle, die zur Ausgabe definiert sind
Dim c As New Collection
Dim diff(1 To 1024) As Long
Dim linear As Boolean
Dim accel As Long
Dim n As Long
Dim locked As Boolean

Private Sub cb_active_Click()
    If cb_active.value Then
        locked = False
        timer.Enabled = True
    Else
        locked = True
        timer.Enabled = False
    End If
End Sub

Private Sub Form_Load()
    timer.Enabled = False
    locked = True
End Sub

Private Function IDMXCTool_AskToSaveProjectData() As Boolean

End Function

Private Sub IDMXCTool_ClearProjectData()

End Sub

Public Sub IDMXCTool_LoadProjectData()
    Dim filename As String
    Dim i As Integer
    
    filename = GetIniFilename
    
    If Not FileExists(filename) Then
        Exit Sub
    End If
    
    n = GetIni(filename, "Options", "Count", 0)
    
    If n = 0 Then
        Exit Sub
    End If
    
    For i = 1 To n
        c.Add GetIni(filename, "Data", "x" & i, "0000"), "dev." & CStr(i) & ".pan"
        c.Add GetIni(filename, "Data", "y" & i, "0000"), "dev." & CStr(i) & ".tilt"
    Next i
    
    accel = CLng(GetIni(filename, "Options", "Acceleration", 50))
    Dim tol As Long
    tol = CLng(GetIni(filename, "Options", "Tolerance", 5))
    tolmin = 128 - tol
    tolmax = 128 + tol
    
    If GetIni(filename, "Options", "Mode", "lin") = "lin" Then
        linear = True
    Else
        linear = False
    End If
    
    timer.Interval = accel
End Sub

Private Sub IDMXCTool_SaveProjectData()

End Sub

Private Property Let IDMXCTool_ViewMode(ByVal RHS As DMXCTypeLib.View)

End Property

Private Function IExternalWindow_hideWindow() As Boolean
    Me.Hide
End Function

Private Property Get IExternalWindow_isOpen() As Boolean
    Dim Frm As Form

    For Each Frm In Forms
        If StrComp(Frm.Name, Me.Name, vbTextCompare) = 0 Then
            IExternalWindow_isOpen = True
            Exit For
        End If
    Next
End Property

Private Function IExternalWindow_loadWindow() As Boolean
    Load Me
End Function

Private Function IExternalWindow_showWindow() As Boolean
    Me.Show
End Function


Private Function IExternalWindow_unloadWindow() As Boolean
    Unload Me
End Function

Private Property Let IExternalWindow_WindowState(RHS As Long)
    Me.WindowState = RHS
End Property

Private Property Get IExternalWindow_WindowState() As Long
    IExternalWindow_WindowState = Me.WindowState
End Property

Private Function ICommandServer_ExecuteCommand(FirstSelection As String, SecondSelection As String, NewValue As Long, Optional Stream As DMXCTypeLib.IDMXMixerChannel, Optional AdditionalData As PropertyBag) As Variant
    Dim diffl As Double
    Dim channel As Long
    Dim absolute As Long

    absolute = Round(256 * (NewValue / 100000))
    
    If (absolute >= tolmin) And (absolute <= tolmax) Then
        channel = CLng(c(SecondSelection))
        diff(channel) = 0
        Exit Function
    End If
    
    channel = CLng(c(SecondSelection))
    
    If absolute >= 128 Then
        diffl = absolute - 128
    Else
        diffl = 128 - absolute
        diffl = diffl * -1
    End If
    
    If linear Then
        diffl = Round(diffl / 10)
    Else
        If diffl >= 0 Then
            diffl = Round(Log(diffl))
        Else
            diffl = diffl * -1
            diffl = Round(Log(diffl))
            diffl = diffl * -1
        End If
    End If

    diff(channel) = diffl
    
    If Not timer.Enabled Then
        If Not locked Then
            timer.Enabled = True
        End If
    End If
End Function

Private Function ICommandServer_GetFirstOptions() As DMXCTypeLib.IKeyCollection
    Dim i As Integer
    Set ICommandServer_GetFirstOptions = New KeyCollection
    With ICommandServer_GetFirstOptions
        For i = 1 To n
            .Add DMXCHelper.Translator.Translate(CStr(i)), "dev." & CStr(i)
        Next i
    End With
End Function


Private Function ICommandServer_GetSecondOptions(FirstSelection As String) As DMXCTypeLib.IKeyCollection
    Dim i As Integer
    Set ICommandServer_GetSecondOptions = New KeyCollection
    With ICommandServer_GetSecondOptions
        For i = 1 To n
            If FirstSelection = "dev." & CStr(i) Then
                .Add DMXCHelper.Translator.Translate("Pan"), "dev." & CStr(i) & ".pan"
                .Add DMXCHelper.Translator.Translate("Tilt"), "dev." & CStr(i) & ".tilt"
            End If
        Next i
    End With
End Function

Private Property Get ICommandServer_Name() As String
    ICommandServer_Name = "DMXJoystick"
End Property


Private Sub timer_Timer()
    Dim ch As Variant
    Dim channel As Long
    Dim value As Long
    
    For Each ch In c
        channel = CLng(ch)
        If channel > 0 Then
            value = DMXCHelper.ChannelGetValue(channel)
            value = value + diff(CLng(channel))
            Call DMXCHelper.MyStream.UserInteraction
            Call DMXCHelper.MyStream.SetChannel(channel, value, True)
        End If
    Next ch
End Sub

Public Sub setAccel(ByVal pAccel As Long)
    accel = pAccel
    timer.Interval = accel
End Sub

Public Sub setTolerance(ByVal pTol As Long)
    tolmin = 128 - pTol
    tolmax = 128 + pTol
End Sub

Public Sub setMode(ByVal pMode As String)
    If pMode = "lin" Then
        linear = True
    Else
        linear = False
    End If
End Sub
